const query = getQuery()

let basedir = query["base"];

if(basedir) {
   basedir = decodeURI(basedir)
}

if(!basedir) {
    loadConfig()
} else {
    document.getElementById("menu").style.display =  document.getElementById("empty").style.display = document.getElementById("detail").style.display = "block"
    document.getElementById("first").style.display = "none"
}

// 2025.03.22
// 新增右键功能
function newWindowOpenFile() {
  const a = document.createElement("a")
  a.target = "_blank"
  a.href = location.href
  a.click()
  closeRightMenu()
}
 
// 唯一标识: uploadFile
function uploadFileHandle(e) {
  const fileInput = document.querySelector("#uploadFile")
  const file = fileInput.files[0];
  
  
  const copy = document.querySelector(".menu-row-active")
  let path, icon

  if(!copy) {
     path = getNewPath()
     icon = "dir"
  } else {
     path = copy.dataset.path
     icon = copy.dataset.icon
  }

  

  if(icon != "dir") {
    path = document.querySelector(".menu-row-active").parentElement.parentElement.dataset.path
  }
 
  if(!path) {
     alert("出错了")
     return false
  }

  if(file) {
    const formData = new FormData();
    formData.append('file', file); 
    fetch(`/file.php?act=upload&path=${path}`, {
        method: 'POST',
        body: formData
    })
    .then(response => response.json())
    .then(data => {
        // 刷新目录
        reloadDir()
    })
    .catch(error => {
        console.error('Error uploading file:', error);
    });
  }
  fileInput.value = ""
}

function uploadFile() {
   closeRightMenu()
   document.querySelector("#uploadFile").click()
}
function deleteFile() {
    if(!confirm("你确定要删除文件？")) {
       return
    }

    const copy = document.querySelector(".menu-row-active")
    if(!copy) {
       alert("非法操作")
       return
    }
    let path = copy.dataset.path.replace(basedir, "")
     
    fetch("/file.php?act=remove", {
        method: "post",
        body: JSON.stringify({
            path: path,
            base: basedir
        })
    }).then(function(body) {return body.json()}).then(function(data) {
        if(data.error) {
            alert(data.error)
            return
        }
        
        reloadDir()
    }).catch(function(error) {
       console.log(error)
    })
    closeRightMenu()
}

function closeRightMenu() {
    const menu = document.getElementById("menu-right")
    menu.style.display = "none"
}
function openRightMenu(path, name, icon, event, layer, event) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }
    const menu = document.getElementById("menu-right")
    menu.style.display = "block"
    menu.style.left = event.clientX + "px"
    menu.style.top = event.clientY + "px"
    menu.dataset.path = path
    menu.dataset.name = name
    menu.dataset.icon = icon
    menu.dataset.layer = layer
    
    if(icon == "dir") {
      document.getElementById("menu-right-file").style.display = "block"
      document.getElementById("menu-right-dir").style.display = "block"
   
      // document.getElementById("moveDirMenu").style.display = "block"
      // document.getElementById("moveFileMenu").style.display = "none"
    } else {
       document.getElementById("menu-right-file").style.display = "none"
       document.getElementById("menu-right-dir").style.display = "none"

       // document.getElementById("moveDirMenu").style.display = "none"
       // document.getElementById("moveFileMenu").style.display = "block"
    }
    
    
    document.querySelector(`.menu-row-active`).className = "menu-row"

    document.querySelector(`.menu-row[data-path='${path}']`).className = "menu-row menu-row-active menu-row-active-selected"
}

// 复制目录 TYPE: 0，复制目录 1，复制相对目录
function copyDir(event, type) {
    console.log(type)
    const copy = document.querySelector(".menu-row-active")
    if(!copy) {
        return
    }
    let path = copy.dataset.path
    
    if(type == 0) {
    } else if(type == 1) {
        path = path.replace(basedir, "")
    }
    console.log(path)
    // 复制到剪切板要兼容性好一点
    const input = document.createElement("input")
    input.value = path
    document.body.appendChild(input)
    input.select()
    document.execCommand("copy")
    document.body.removeChild(input)
   
    closeRightMenu()
}

// 重命名
function dirRename() {
    const copy = document.querySelector(".menu-row-active")
    if(copy != null) {
        event.preventDefault()
        event.stopPropagation()

        const element = document.querySelector(".menu-row-active .menu-element .file-name .file-name-ext")
               
        const elementTxt = document.querySelector(".menu-row-active .menu-element .file-name .file-name-text")
        const filename = elementTxt.textContent

        element.innerHTML = `<input value="${filename}" onclick="stopEvent(event)" onblur="toChangeFileName(event)" />`
        document.querySelector(".menu-row-active").className = "menu-row menu-row-active"
        elementTxt.style.display = "none"
        element.style.display = "block"
    }
    closeRightMenu()
}
// 结束

function backLastDir(event) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    } 
    
    const path = document.getElementById("file-select-keyword-path").value
    let pathArray = path.split("/")
    pathArray.pop()

    document.getElementById("file-select-keyword-path").value=pathArray.join("/")
    document.getElementById("file-select-keyword-path").onchange(event)
}

function goNextDir(event) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }
    const obj = document.querySelector(".menu-row-dir-active")
    if(!obj) {
      alert("请选择目录")
      return
    }

    const path =  obj.dataset.filePath
    document.getElementById("file-select-keyword-path").value=path
    document.getElementById("file-select-keyword-path").onchange(event)
}

function loadConfig() {
    fetch("/file.php?act=config").then(function(body) {return body.json()}).then(function(data) {
        let html = "", path, name, array;
        const history = data.history

        for(var i = 0; i < Object.keys(history).length; i++) {
            path = history[Object.keys(history)[i]]
            array = path.split("/")
            name = array.pop()
            dir = array.join("/")
            
            html += `<li>
                <a href="?base=${path}">${name}</a>
                <span class="history-dirname">${dir}</span>
            </li>`
        }
       document.querySelector(".wecome-row-history ul").innerHTML = html
       if(html) {
            document.querySelector(".wecome-row-history").style.display = "block"
       }
    }).catch(function(e) {
        console.log(e)
    })
}

let sourceContent = {}

openProject(basedir, true)

function listenClose(event) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    } 
    
    try {onMenuAddFile()} catch(e) {}
    try {closeRightMenu()} catch(e) {}




    try {toChangeFileName()} catch(e) {}

    
     document.getElementById("search-name").style.display = "none"
    
}

function menuListen(event) {
    event.preventDefault()
    event.stopPropagation()
    
try {
    closeRightMenu()
} catch(e) {}

    toChangeFileName()

      

    try {
        document.querySelector(`.menu-row-active`).className = "menu-row"
       
    } catch(e) {}

    
}

function newFile(event) {
    try {document.querySelector(".menu-row-add").remove()  } catch(e) {}

    try {closeRightMenu()  } catch(e) {}
      
    event.preventDefault()
    event.stopPropagation()

    const path = getNewPath()

    console.log(path)

    const parent = document.querySelector(`.menu-row[data-path='${path}'] .menu-element`)

    let paddingLeft = 12
    try {
        paddingLeft = (parseInt(parent.style.paddingLeft))
    } catch(e) {
        paddingLeft = 12
    }
    console.log(paddingLeft)
    const parentSmall = document.querySelector(`.menu-row[data-path='${path}'] .menu-row-small`)

    parentSmall.style.display = "block"

    parentSmall.insertBefore(document.createElement("div"), parentSmall.firstChild).innerHTML = `<div class="menu-row menu-row-add">
        <div class="menu-row menu-element" style="display: flex;align-items: center;padding: 0 ${paddingLeft}px;">
            <span class="icon icontext">📄</span>
            <span class="file-name" style="flex: 1;">
             <span class="file-name-ext"><input value="" onclick="stopEvent(event)" data-path="${path}" data-icon="" onblur="onMenuAddFile(event)" /></span>
            </span>
        </div>
    </div>`

    event.preventDefault()
    event.stopPropagation()

    document.querySelector(".menu-element .file-name-ext input").focus()

    toChangeFileName()
    document.querySelector(".menu-row-active-selected").className = "menu-row menu-row-active"
}

function onOpenSelectMenuAddFile(event) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }

    const a = document.querySelector(".menu-row-open-add input")
    
    if(!a.value) {
        try {document.querySelector(".menu-row-open-add").remove()} catch(e) {}
        return
    }
    
    a.style.display = "none"
    
    console.log(a)

    
    // if(addPath == a.dataset.path + "/" + a.value) {
    //     try {document.querySelector(".menu-row-open-add").remove()} catch(e) {}
    //     return
    // }

    addPath = a.dataset.path + "/" + a.value


    fetch("/file.php?act=addFileName", {
        method: "post",
        body: JSON.stringify({
            path: a.dataset.path,
            name: a.value,
            icon: a.dataset.icon
        })
    }).then(function(body) {return body.json()}).then(function(data) {
        if(data.error) {
            alert(data.error)
            try {document.querySelector(".menu-row-open-add").remove()} catch(e) {}
            return
        }

        try {document.querySelector(".menu-row-open-add").remove()} catch(e) {}
        
        onSearchByNameDirPathHandle(event)
    }).catch(function(e) {
        console.log(e)
        a.style.display = "block"
    })
}

function newSelectDir(event) {
    try {document.querySelector(".menu-row-open-add").remove()  } catch(e) {}
    const path = document.getElementById("file-select-keyword-path")

    const menu = document.getElementById("file-select-core")
    menu.insertBefore(document.createElement("div"), menu.firstChild).innerHTML = `<div class="menu-row menu-row-open-add">
        <div class="menu-row menu-element" style="display: flex;align-items: center;padding: 0 12px;">
            <span class="icon icontext">> </span>
            <span class="file-name" style="flex: 1;">
            <span class="file-name-ext"><input id="newSelectDir" value="" onclick="stopEvent(event)" data-path="${path.value}" data-icon="dir" onblur="onOpenSelectMenuAddFile(event)" /></span>
            </span>
        </div>
    </div>`
    document.querySelector(".menu-element .file-name-ext input").focus()
}

function newDir(event) {
    try {document.querySelector(".menu-row-add").remove()  } catch(e) {}

    try {closeRightMenu()  } catch(e) {}

    event.preventDefault()
    event.stopPropagation()

    const path = getNewPath()

    const parent = document.querySelector(`.menu-row[data-path='${path}'] .menu-element`)
    let paddingLeft = 12
    try {
        paddingLeft = (parseInt(parent.style.paddingLeft))
    } catch(e) {
        paddingLeft = 12
    }
    const parentSmall = document.querySelector(`.menu-row[data-path='${path}'] .menu-row-small`)

    parentSmall.style.display = "block"

    parentSmall.insertBefore(document.createElement("div"), parentSmall.firstChild).innerHTML = `<div class="menu-row menu-row-add">
        <div class="menu-row menu-element" style="display: flex;align-items: center;padding: 0 ${paddingLeft}px;">
            <span class="icon icontext">> </span>
            <span class="file-name" style="flex: 1;">
             <span class="file-name-ext"><input value="" onclick="stopEvent(event)" data-path="${path}" data-icon="dir" onblur="onMenuAddFile(event)" /></span>
            </span>
        </div>
    </div>`

    event.preventDefault()
    event.stopPropagation()

    document.querySelector(".menu-element .file-name-ext input").focus()

    toChangeFileName()
    document.querySelector(".menu-row-active-selected").className = "menu-row menu-row-active"
}

function getNewPath() {
    const element = document.querySelector(`.menu-row-active`)
    if(element) {
        const path = document.querySelector(`.menu-row-active`).dataset.path
        const isdir = document.querySelector(`.menu-row-active .menu-row .icondir`)
        if(isdir != null) {
            return path
        } else {
            return document.querySelector(`.menu-row-active`).parentElement.parentElement.dataset.path
        }
    } else {
        return basedir   
    }
}

function closeEdit() {
    window.location.href = "/"
}

function reloadDir(event) {
    if(event) {
    event.preventDefault()
    event.stopPropagation()
}

    openProject(basedir)
}

function selectDirAndOpenProject() {
    const obj = document.querySelector(".menu-row-dir-active")
    // const fileSelect = document.querySelector("#file-select-option-core")
    const fileSelect = document.querySelector("#file-select-keyword-path")
    
    if(obj) {
        basedir = obj.dataset.filePath
    } else if(fileSelect) {
        basedir = fileSelect.value
    }
    
    window.location.href = "?base=" + basedir
    openProject(basedir, true)
    document.getElementById("file-selec-box").style.display = "none"
}

function selectDirClose() {
    document.getElementById("file-selec-box").style.display = "none"
}

function getQuery() {
    let arr = window.location.search.split("&")
    arr[0] = arr[0].substr(1)
    
    let query = {}, row;
    for(var i = 0; i < arr.length; i++) {
        row  = arr[i].split("=")
        query[row[0]] = row[1]
    }
    return query
}

function updateTab(oldPath, newPath, name, icon) {
    if(icon != "dir") {
        let files = JSON.parse(localStorage.getItem(basedir + "files"))
        if(!files) {files = {}} 
        files[newPath] = files[oldPath]
        files[newPath].name = name  
        files[newPath].icon = icon
        files[newPath].path = newPath
        
        files[oldPath] = undefined      
        localStorage.setItem(basedir + "files", JSON.stringify(files))
        localStorage.setItem(basedir + "paths", newPath)
        document.getElementById("files").innerHTML = getFiles()
    } else {
        let files = JSON.parse(localStorage.getItem(basedir + "files"))
        if(!files) {files = {}} 

        // 循环files对象
        // 并且判断每一个 files 对象，是否包含 oldPath, 如果包含 就需要替换 新路径
        for(let i = 0; i < Object.keys(files).length; i++) {
            let row = files[Object.keys(files)[i]]
            console.log(row.path, oldPath, Object.keys(files)[i])
            if(row.path.indexOf(oldPath) === 0) {
                let path = row.path.replace(oldPath, newPath)
               
                files[path] = row
                files[path].path = path

                files[Object.keys(files)[i]] = undefined    
            }
        }
        console.log(files)
        
        const paths = localStorage.getItem(basedir + "paths")
        if(paths != null && paths.indexOf(oldPath) === 0) {
            localStorage.setItem(basedir + "paths",  paths.replace(oldPath, newPath))
        }

        localStorage.setItem(basedir + "files", JSON.stringify(files))
        document.getElementById("files").innerHTML = getFiles()
    }
}

function toLogin(fun = false) {
    var password =  prompt("请输入授权密码")
    if(password) {
        fetch("/file.php?act=login" + "&password=" + password).then(function(body) {return body.text()}).then(function(data) {
            if(data == -1) {
                alert("授权密码错误")
            }

            if(data == 1) {
                fun && fun()
            }
        }).catch(function(e) {
        })
    }
}

function openProject(base = "", log = false) {
    fetch("/file.php?act=dir" + (base ? "&base=" + base : "")  + (log ? "&open=" + log : "")).then(function(body) {return body.json()}).then(function(data) {
        
        if(data === 0) {
            toLogin(function() {
                openProject(base, log)
            })
            return 
        }

        if(data === -2) {
           window.location.href = "./install.php"
            return
        }

        const content = makeHtml(data)
        const files = getFiles()
    
        document.getElementById("menu-box").innerHTML = content
        document.getElementById("files").innerHTML = files

        document.getElementById("menu").style.display = "block"
        document.getElementById("detail").style.display = "block"
        document.getElementById("first").style.display = "none"
    
        menuSelected()
    }).catch(function(e) {
        document.getElementById("menu").style.display = "none"
        document.getElementById("detail").style.display = "none"
        document.getElementById("first").style.display = "block"

        if(log) {
            loadConfig()
        }
    })
}

document.addEventListener("keydown", function(event) {
    console.log(event)
    let obj = document.getElementById("search-name")

    if((event.ctrlKey == true || event.metaKey == true) && event.keyCode == '80') {
        let display = document.getElementById("search-name").style.display
        obj.style.display = (display  == "none" ? "block" : "none")
        document.getElementById("keyword").focus()
        event.preventDefault()
        document.getElementById("keyword").value = ""
        onSearchByName()
        event.preventDefault()
        return
    }

    if((event.ctrlKey == true || event.metaKey == true) && event.keyCode == '87') {
        removeLastTabs()
        event.preventDefault()
        event.stopPropagation()
        return
    }

    if((event.ctrlKey == true || event.metaKey == true) && event.keyCode == '83') {
        saveToService(event)
        return
    }

    // 监听回车
    if( event.keyCode == '13') {
        // 检查事件目标是否是 commentContent
        if (event.target.id === 'content') {
            return; // 如果目标是 commentContent，直接返回
        }

        if(event.target.id === 'newSelectDir') {
            newSelectDir()
            return
        }
        
            const copy = document.querySelector(".menu-row-active-selected")
            if(copy != null) {
                event.preventDefault()
                event.stopPropagation()

                const element = document.querySelector(".menu-row-active-selected .menu-element .file-name .file-name-ext")
               
                const elementTxt = document.querySelector(".menu-row-active-selected .menu-element .file-name .file-name-text")
                const filename = elementTxt.textContent

                element.innerHTML = `<input value="${filename}" onclick="stopEvent(event)" onblur="toChangeFileName(event)" />`
                document.querySelector(".menu-row-active-selected").className = "menu-row menu-row-active"
                elementTxt.style.display = "none"
                element.style.display = "block"
            } else {
                const add = document.querySelector(".menu-row-add .menu-element .file-name input")
                if(add != null) {
                    // 按下回车 同时 触发 失去焦点事件
                    onMenuAddFile()
                    return
                }

                const input = document.querySelector(".menu-row-active .menu-element .file-name input")
                if(input != null) {
                    toChangeFileName()
                }
            }
            
            console.log(copy)

    }
})

let addPath = ""
function onMenuAddFile(event) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }
    const a = document.querySelector(".menu-row-add input")
    
    if(!a.value) {
        try {document.querySelector(".menu-row-add").remove()} catch(e) {}
        return
    }
    
    a.style.display = "none"
    
    console.log(a)

    
    if(addPath == a.dataset.path + "/" + a.value) {
        try {document.querySelector(".menu-row-add").remove()} catch(e) {}
        return
    }

    addPath = a.dataset.path + "/" + a.value


    fetch("/file.php?act=addFileName", {
        method: "post",
        body: JSON.stringify({
            path: a.dataset.path,
            name: a.value,
            icon: a.dataset.icon
        })
    }).then(function(body) {return body.json()}).then(function(data) {
        if(data.error) {
            alert(data.error)
            try {document.querySelector(".menu-row-add").remove()  } catch(e) {}
            return
        }

        try {document.querySelector(".menu-row-add").remove()  } catch(e) {}
        
        const o = document.querySelector(`.menu-row[data-path='${a.dataset.path}']`)
        getContent(o.dataset.path, o.dataset.name, "dir", false, parseInt(o.dataset.layer), 0 ,0 ,1, function() {
            getContent(data.path, data.name, data.icon, false, parseInt(o.dataset.layer) + 1, 0 ,0 , 1)
        })
    }).catch(function(e) {
        console.log(e)
        a.style.display = "block"
    })
}

function toChangeFileName(event) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }
    
    const path = document.querySelector(".menu-row-active").dataset.path
    const newFileName = document.querySelector(".menu-row-active .menu-element .file-name input").value
    const fileName = document.querySelector(".menu-row-active .menu-element .file-name-text").textContent

    if(!newFileName) {
        return
    }

    if(newFileName != fileName) {
        document.querySelector(".menu-row-active .menu-element .file-name-text").innerHTML = newFileName

        fetch("/file.php?act=editFileName", {
            method: "post",
            body: JSON.stringify({
                path: path,
                new_name: newFileName,
                old_name: fileName
            })
        }).then(function(body) {return body.json()}).then(function(data) {
            if(data.error) {
                alert(data.error)
                return
            }
            
            document.querySelector(".menu-row-active .menu-element .file-name-text").style.display = "block"
            document.querySelector(".menu-row-active .menu-element .file-name-ext").style.display = "none"
            document.querySelector(".menu-row-active").className = "menu-row menu-row-active menu-row-active-selected"

            const o = document.querySelector(`.menu-row[data-path='${path}']`)
            const i = document.querySelector(`.menu-row[data-path='${path}'] .icon`)
            o.dataset.path = data.path
            o.dataset.name = data.name
            o.dataset.icon = data.icon

            // 去除之前的 onclick 事件
            o.onclick = function(event) {
                getContent(o.dataset.path, o.dataset.name, o.dataset.icon, event, parseInt(o.dataset.layer), 1 ,1)
            }
            
            i.onclick = function(event) {
                getContent(o.dataset.path, o.dataset.name, o.dataset.icon, event, parseInt(o.dataset.layer), 0 ,0)
            }

            console.log(path, data.path, data.name, data.icon)
            updateTab(path, data.path, data.name, data.icon)

            if(data.icon == "dir") {
                getContent(o.dataset.path, o.dataset.name, "dir", false, parseInt(o.dataset.layer), 0 ,0 ,1)
            }
        }).catch(function(e) {
            console.log(e)
        })
    } else {
        document.querySelector(".menu-row-active .menu-element .file-name-text").style.display = "block"
        document.querySelector(".menu-row-active .menu-element .file-name-ext").style.display = "none"
        document.querySelector(".menu-row-active").className = "menu-row menu-row-active menu-row-active-selected"
    }
}

function stopEvent(event) {
    event.preventDefault()
    event.stopPropagation()
}

function onSearchByNameHandle() {
    let obj = document.getElementById("search-name")
    obj.style.display = "block"
    document.getElementById("keyword").value = ""
    onSearchByName()
}

function menuSelected(ismenu=0) {
    try {
        document.querySelector(`.menu-row-active`).className = "menu-row"
    } catch(e) {}
    
    const paths = localStorage.getItem(basedir + "paths")
    
    try {
        if(ismenu) {
            document.querySelector(`.menu-row[data-path='${paths}']`).className = "menu-row menu-row-active menu-row-active-selected"
        } else {
            document.querySelector(`.menu-row[data-path='${paths}']`).className = "menu-row menu-row-active"
        }
        
        openMoreMenu(document.querySelector(`.menu-row[data-path='${paths}']`))
    } catch(e) {}
}

function openMoreMenu(el) {
    if(!el || el.id == "menu" || el.id == "file-selec-box") return

    el.parentElement.style.display = "block"
    
    if(el != document.getElementById("menu")) {
        openMoreMenu(el.parentElement)
    }
}

let timerJs = null
function double(fun, timer) {
    if(timerJs) clearTimeout(timerJs)  
    timerJs = setTimeout(function() {
        console.log(timer)
        fun()
    }, timer)
}

function onKeywordSearch() {
    const keyword = document.getElementById("keyword").value
    
    double(function() {
        onSearchByName(keyword)
    }, 0)
    
}

function onSearchByName(e) {
    const base = basedir
    fetch("/file.php?act=search" + (base ? "&base=" + base : "") + (e ? "&keyword=" + e : "")).then(function(body) {return body.json()}).then(function(data) {
        if(data === 0) {
            toLogin(function() {
                onSearchByName(e)
            })
            return 
        }

        if(data === -2) {
           window.location.href = "./install.php"
            return
        }

        let row = null, html = ""
        for(var i = 0; i < Object.keys(data).length; i++) {
            row = data[Object.keys(data)[i]]
            html += `<div class="menu-row search-menu-row" title="${row.path}" onclick="getContent('${row.path}','${row.name}', '${row.icon}', event)" style="display: flex;"><span class="icon icon${row.icon}">${getIconText(row.icon)} </span><span>${row.name}</span><span style="flex: none;">&nbsp;${row.desc}</span></div>`
        }
    
        document.getElementById("search-result-box").innerHTML = html
        
    })
}

function makeHtml(data, layer = 0) {
    let row = null, html = ""

    for(var i = 0; i < Object.keys(data).length; i++) {
        
        row = data[Object.keys(data)[i]]
        
        html += `<div class="menu-row" title="${row.name}" data-path="${row.path}" data-icon="${row.icon}" data-name="${row.name}" data-layer="${layer}" onclick="getContent('${row.path}','${row.name}', '${row.icon}', event, ${layer}, 1, 1)">
        
        <div oncontextmenu="openRightMenu('${row.path}','${row.name}', '${row.icon}', event, ${layer}, event)" class="menu-row ${layer != 0 ? 'menu-element' : ''}" style="display: flex;align-items: center;padding: 0 ${(layer + 1) * 12}px;">
            <span onclick="getContent('${row.path}','${row.name}', '${row.icon}', event, ${layer}, 0)" class="icon icon${row.icon}">${getIconText(row.icon)} </span><span style="flex: none;" class="file-name"><span class="file-name-text">${row.name}</span><span class="file-name-ext"></span></span>
        </div>

        <div class="menu-row-small" style="display: none;">
            ${row.child ? makeHtml(row.child, layer + 1) : ''}
        </div>

        </div>`
    }
    return html
}

function getFiles() {
    let files = JSON.parse(localStorage.getItem(basedir + "files"))
    const paths = localStorage.getItem(basedir + "paths")
    if(!files) {files = {}}

    console.log(files)
    let row = null, html = ""
    for(var i = 0; i < Object.keys(files).length; i++) {
        row = files[Object.keys(files)[i]]
        if(!row.path) continue;
        if(row.path == paths) {
            _getContent(row.path)
        }
        console.log(row.path)
        console.log(Object.keys(files)[i])
        html += `<div class="files-row menu-row ${paths == Object.keys(files)[i] ? 'menu-row-selected' : ''}" title="${row.path}"><div style="padding: 12px;" onclick="getContent('${Object.keys(files)[i]}','${row.name}', '${row.icon}', event)"><span class="icon icon${row.icon}">${getIconText(row.icon)} </span><span>${row.name}</span></div>
            <div class="tabclose tabclose_${row.change ? 1 : 0}" onclick="removeTabs('${Object.keys(files)[i]}','${row.name}', '${row.icon}', event, ${row.change ? 1 : 0})">
                <span class="start" style="display: none;">*</span>
                <span class="close" style="font-size: 10px;">❌</span>
            </div>
        </div>`
    }

    if(!html) {
        document.getElementById("empty").style.display = "block"
        document.getElementById("core").style.display = document.getElementById("files").style.display = "none"
    }
    else {
        document.getElementById("files").style.display = "flex"
        document.getElementById("core").style.display = "flex"
        document.getElementById("empty").style.display = "none"
    }
    
    return html
}

function getIconText(icon) {
    if(icon == "dir") return ">"
    if(icon == "html") return "<>"
    if(icon == "php") return "🐘"
    if(icon == "java") return "☕️"
    if(icon == "c") return "💻"
    if(icon == "py") return "🤖"
    if(icon == "css") return "#"
    if(icon == "json") return "{}"
    if(icon == "ico") return "✨"
    if(icon == "lock") return "🔒"
    if(icon == "sql") return "🧍‍♂️"
    if(icon == "png" || icon == "gif" || icon == "jpg") return "📷"
    if(icon == "css") return "css"
    if(icon == "js") return "js"
    if(icon == "html") return "html"
    return ""
}

function removeLastTabs() {
    let files = JSON.parse(localStorage.getItem(basedir + "files"))

    const paths = localStorage.getItem(basedir + "paths")

    if(paths && files[paths]) {
        files[paths] = undefined

        removeTabs(paths)
        return
    }


    if(Object.keys(files).length > 0) {
        const i = Object.keys(files).length - 1
        const last = files[Object.keys(files)[i]]

        removeTabs(last.path)
        return
    }
}

function removeTabs(path, name, icon, event, change = 0) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }

    if(1 == change) {
        if(confirm("当前文件还没有保存，确定要关闭？")) {

        } else {
            return
        }
    }

    let files = JSON.parse(localStorage.getItem(basedir + "files"))
    if(!files) {
        files = {}
    }
    files[path] = undefined
    

    localStorage.setItem(basedir + "files", JSON.stringify(files))

    document.getElementById("files").innerHTML = getFiles()

    
    files = JSON.parse(JSON.stringify(files))
    if(Object.keys(files).length > 0) {
        const i = Object.keys(files).length - 1
        const last = files[Object.keys(files)[i]]
        if(last) {
            getContent(last.path, last.name, last.icon)
            localStorage.setItem(basedir + "paths", last.path)
        } else {
            document.getElementById("content").value = ""
        }
    } else {
        document.getElementById("content").value = ""
    }
}

function addNewFileEvent(event) {
    document.getElementById("first").style.display = "none"
    document.getElementById("detail").style.display = "block"
    addNewFile(event)
}

function getLastParentDir(path) {
    if(!path) return

    let array = path.split("/");
    array.pop()
    
    const paths = array.join("/");
    return paths;
}

function openDirSelect(event) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    } 
    openChildDir(document.getElementById("file-select-option-core").value)
}

function openDir(event) {
    document.querySelector(".file-save").style.display = "none"
    // document.querySelector("#file-select-core").style.paddingTop = "0"
    document.querySelector("#file-select .file-submit").innerText = "打开"
    document.querySelector("#file-select-core").style.marginTop = "48px"
    document.querySelector("#file-select-core").style.height = "calc(100% - 100px)"
    let pathDir = ""
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }
    openChildDir(pathDir ? pathDir : getLastParentDir(basedir))
}

function openChildDir(pathDir="", event="") {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }
    fetch("/file.php?act=part_dir" + (pathDir ? "&path=" + pathDir : "")).then(function(body) {return body.json()}).then(function(data) {
        if(data === 0) {
            toLogin(function() {
                openChildDir(pathDir, event)
            })
            return 
        }

        if(data === -2) {
           window.location.href = "./install.php"
            return
        }
        
        const path = data.path
        const array = path.split("/")

        document.getElementById("file-select-keyword-path").value = array.join("/")

        let fileSelectOption = ""

        console.log(array.length)
        if(array.length <= 2) {
            fileSelectOption += `<option value="/">/</option>`
        }

        for(var i =0; i < array.length;i++) {
            if(!array[i]) continue;
            fileSelectOption += `<option value="${array.slice(0, i + 1).join("/")}">${array[i]}</option>`
        }
        document.getElementById("file-select-option-core").innerHTML = fileSelectOption
        document.getElementById("file-select-option-core").value = document.getElementById("file-select-keyword-path").value

        let obj = document.getElementById("file-selec-box")
        obj.style.display = "block"
        const keyword = document.getElementById("file-select-keyword").value
        const _path_ = document.getElementById("file-select-keyword-path").value
        onSearchByNameDir(keyword, _path_)
    })
}

function onSearchByNameDirHandle(event) {
    if(event) {
        event.preventDefault()
    }
    const keyword = document.getElementById("file-select-keyword").value
    double(function() {
        onSearchByNameDir(keyword, "")
    }, 0)
}

function onSearchByNameDirPathHandle(event) {
    if(event) {
        event.preventDefault()
    }
    const path = document.getElementById("file-select-keyword-path").value
    if(!path) {
        document.getElementById("file-select-keyword-path").value = "/"
    }
    double(function() {
        onSearchByNameDir("", path)
    }, 0)
}

function onSearchByNameDir(e, path) {
    fetch("/file.php?act=open_dir" + "&keyword=" + e + "&path=" + path).then(function(body) {return body.json()}).then(function(data) {
        
        let row = null, html = ""
        for(var i = 0; i < Object.keys(data).length; i++) {
            row = data[Object.keys(data)[i]]
            html += `<div class="menu-row" title="${row.name}" data-file-path="${row.path}">
            <div onclick="selectChildDir('${row.path}', event)" ondblclick="openChildDir('${row.path}', event)" class="menu-row menu-row-dir menu-row-icon${row.icon}" style="display: flex;align-items: center;padding: 0 12px;">
                <span onclick="getChildDir('${row.path}','${row.name}', '${row.icon}', event, 1)" class="icon icon${row.icon}">${getIconText(row.icon)} </span><span style="flex: none;">${row.name}</span>
            </div>
            <div class="menu-row-small" style="display: none;">
            </div>
            </div>`
        }
        document.getElementById("file-select-core").innerHTML = html
    }).catch(function(e) {
        document.getElementById("file-select-core").innerHTML = ""
    })
}

function selectChildDir(path, event) {
    event.preventDefault()
    event.stopPropagation()

    try {
        document.querySelector(".menu-row-dir-active").className = "menu-row"
    } catch(e) {}
    document.querySelector(`.menu-row[data-file-path='${path}']`).className = "menu-row menu-row-dir-active"
}

function getChildDir(path, name, icon, event, layer) {
    if(event) {
        event.stopPropagation()
        event.preventDefault()
    }

    if(icon == 'dir') {
        const e = document.querySelector(`.menu-row[data-file-path='${path}'] .menu-row-small`)
        
        fetch("/file.php?act=open_dir" + "" + (path ? "&path=" + path : "")).then(function(body) {return body.json()}).then(function(data) {
            let row = null, html = ""
            for(var i = 0; i < Object.keys(data).length; i++) {
                row = data[Object.keys(data)[i]]
                html += `<div class="menu-row" title="${row.name}" data-file-path="${row.path}">
                <div onclick="selectChildDir('${row.path}', event)" ondblclick="openChildDir('${row.path}', event)" class="menu-row menu-row-dir menu-row-icon${row.icon}" style="display: flex;align-items: center;padding: 0 ${(layer + 1) * 12}px;">
                    <span onclick="getChildDir('${row.path}','${row.name}', '${row.icon}', event, ${(layer + 2)})" class="icon icon${row.icon}">${getIconText(row.icon)} </span><span style="flex: none;">${row.name}</span>
                </div>
                <div class="menu-row-small" style="display: none;">
                </div>
                </div>`
            }
            e.innerHTML = html

            const icon = document.querySelector(`.menu-row[data-file-path='${path}'] .icondir`)
            icon.className = icon.className.indexOf("icondir-down") != -1 ? "icon icondir" : "icon icondir icondir-down"

            e.style.display = (e.style.display == "block" ? "none" : "block")
        })
        
        
        return
    }
}

function onKeywordSearchDir() {
    const keyword = document.getElementById("keyword").value
    
    double(function() {
        onSearchByNameDir(keyword)
    }, 0)
    
}

function addNewFile(event) {
    listenClose()
   
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }

    let files = JSON.parse(localStorage.getItem(basedir + "files"))

    let count = 1
    if(files) {
        let row = null, key = ""
        for(var i = 0; i < Object.keys(files).length; i++) {
            key = Object.keys(files)[i]
            if(key.indexOf("Untiled") !== false) {
                if(!files["file://Untiled-" + count]) {
                    break
                }
                count += 1;
                if(!files["file://Untiled-" + count]) {
                    break
                }
            }
            
        }
    } else {
        files = {}
    }

    files["file://Untiled-" + count] = {
        name: "Untiled-" + count,
        path: "file://Untiled-" + count,
        icon: "text"
    }

    localStorage.setItem(basedir + "files", JSON.stringify(files))
    localStorage.setItem(basedir + "paths", "file://Untiled-" + count)
    
    document.getElementById("files").innerHTML = getFiles()
}

function getContent(path, name, icon, event, layer, isneedSelect=false, ismenu=false, isopen=false, success=false) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    }
    listenClose()

    if(icon == 'dir') {
        const e = document.querySelector(`.menu-row[data-path='${path}'] .menu-row-small`)
        fetch("/file.php?act=dir" + (path ? "&base=" + path : "")).then(function(body) {return body.json()}).then(function(data) {
            const _data = makeHtml(data[0].child, layer + 1)
            if(_data != e.innerHTML) {
                e.innerHTML = _data
            }
            if(success) {
                success()
            }
        }).catch(function(e) {
        })

    
        if(isneedSelect && layer > 0) {
            try {
                document.querySelector(`.menu-row-active`).className = "menu-row"
            } catch(e) {}
            
            try {
                if(ismenu) {
                    document.querySelector(`.menu-row[data-path='${path}']`).className = "menu-row menu-row-active menu-row-active-selected"
                } else {
                    document.querySelector(`.menu-row[data-path='${path}']`).className = "menu-row menu-row-active"
                }
                
                openMoreMenu(document.querySelector(`.menu-row[data-path='${path}']`))
            } catch(e) {}
        }

        const icon = document.querySelector(`.menu-row[data-path='${path}'] .icondir`)
        icon.className = icon.className.indexOf("icondir-down") != -1 ? "icon icondir" : "icon icondir icondir-down"


        e.style.display = (e.style.display == "block" ? "none" : "block")

        if(isopen) {
            e.style.display = "block"
            icon.className = "icon icondir"
        }
        return
    }
    
    let files = JSON.parse(localStorage.getItem(basedir + "files"))
    if(!files) {
        files = {}
    }
    
    if(!files[path]) {
        files[path] = {
            name: name,
            path: path,
            icon: icon
        }
    }

    localStorage.setItem(basedir + "files", JSON.stringify(files))
    localStorage.setItem(basedir + "paths", path)
    
    document.getElementById("files").innerHTML = getFiles()

    
    document.getElementById("search-name").style.display = "none"

    menuSelected(ismenu)
}

function _getContent(path) {
    let cachePath = path
    if(path.indexOf("file://") === 0) {
        cachePath = basedir + "/" + path
    }

    const cache = localStorage.getItem(cachePath)

    let files = JSON.parse(localStorage.getItem(basedir + "files"))
    if(!files) {files = {}}
    const isCache = ((cache != null) && (cache != undefined) && files && files[path] && files[path].change)
    document.getElementById("footerdir").innerText = path
    if(path.indexOf("file://") === 0) {
        document.getElementById("content").value = cache ? cache : ""
        makeLine()
        document.getElementById("content").focus()
    } else {
        if(isCache) {
            document.getElementById("content").value =  cache
            makeLine()
        }
        
        if(!sourceContent[path]) {
            fetch(`/file.php?act=file&path=${path}`).then(function(body) {return body.text()}).then(function(data) {
                
                if(!isCache) { 
                    document.getElementById("content").value = data
                    makeLine()
                }

                sourceContent[path] = data

                console.log(data)
                console.log(cache)
                if(isCache && data == cache) {
                    fileHaveChange(path, 0)
                }
            })
        }

        if(sourceContent[path] && !isCache) {
            document.getElementById("content").value =  sourceContent[path]
            makeLine()
        }
    }
}

function makeLine() {
    const data = document.getElementById("content").value
    const rows = data.split("\n").length
    document.getElementById("content").style.height = rows * 14 * 1.2 + "px"
            
    let html = "";
    for(var i = 1; i <= rows; i++) {
        html += `<div>${i}</div>`
    }
    
    document.getElementById("line").innerHTML = html
}

function saveLocalCache (event) {
    const data = document.getElementById("content").value
    let fileName = document.querySelector(".menu-row-selected").title
    
    let isLocalFile = false, sourceLocalFile = fileName
    if(fileName.indexOf("file://") === 0) {
        fileName = basedir + "/" + fileName
        isLocalFile = true
    }
    
    // 这里没有问题
    if(sourceContent[fileName] != undefined && sourceContent[fileName] != null) {
        if(sourceContent[fileName] == data) {
            localStorage.removeItem(fileName)
            fileHaveChange(fileName, 0)
        } else {
            localStorage.setItem(fileName, data)
            fileHaveChange(fileName, 1)
        }
    } else {
        if(isLocalFile) {
            localStorage.setItem(fileName, data)
            fileHaveChange(sourceLocalFile, 1)
        } else {
            localStorage.setItem(fileName, data)
            fileHaveChange(fileName, 1)
        }
    }
}

function fileHaveChange(path, change) {
    let files = JSON.parse(localStorage.getItem(basedir + "files"))
    if(!files) {files = {}}

    if(files[path]) {
        files[path].change = change
    }
    
    localStorage.setItem(basedir + "files", JSON.stringify(files))

    document.getElementById("files").innerHTML = getFiles()
}

function listenStatus(event) {
    double(function() {
        makeLine()
        saveLocalCache()
    }, 0)
}

function saveLocalToService(savePath, fileName) {
    // 
    console.log(savePath)
    fetch("/file.php?act=addFileName", {
        method: "post",
        body: JSON.stringify({
            path: savePath,
            name: document.querySelector("#file-save-name").value,
            icon: ""
        })
    }).then(function(body) {return body.json()}).then(function(data) {
        if(data.error) {
            alert(data.error)
            return
        }
        onSearchByNameDirPathHandle(event)

       
        let content = localStorage.getItem(basedir + "/" + fileName)

        fetch("/file.php?act=save", {   
            method: "post",
            body: JSON.stringify({
                path: data.path,
                content: content
            })
        }).then(function(body) {return body.json()}).then(function(fileData) { 
            if(fileData === 0) {
                toLogin(function() {
                    saveToService(event)
                })
                return 
            }
            // 
            // savePath
            console.log(savePath)
            if(fileData.result == "ok") {
                localStorage.removeItem(basedir + "/" + fileName)
                fileHaveChange(fileName, 0)
                removeTabs(fileName)

                const o = document.querySelector(`.menu-row[data-path='${savePath}']`)
                getContent(o.dataset.path, o.dataset.name, "dir", false, parseInt(o.dataset.layer), 0 ,0 ,1, function() {
                    getContent(data.path, data.name, data.icon, false, parseInt(o.dataset.layer) + 1, 0 ,0 , 1)
                })

                sourceContent[data.path] = data.content
                document.getElementById("content").value =  sourceContent[data.path]
                makeLine()
            }
        }).catch(function(e) {
           console.log(e)
        })

         // 获取内容

          // 选中文件

          // 保存内容

          // 关闭节点
        
    }).catch(function(e) {
        console.log(e)
        a.style.display = "block"
    })
    


   
    document.getElementById("file-selec-box").style.display = "none"
    document.querySelector(".file-save").style.display = "none"
}

function openDirSelectSave(event, fileName) {
    if(event) {
        event.preventDefault()
        event.stopPropagation()
    } 
    openChildDir(basedir)
    document.querySelector("#file-select .file-submit").innerText = "存储"
    
    setTimeout(function() {
        document.querySelector(".file-save").style.display = "block"
        document.querySelector("#file-save-name").value = fileName.replace("file://", "")
        // document.querySelector("#file-select-core").style.paddingTop = "36px"
        // document.querySelector("#file-select-core").style.marginTop = "48px"
        document.querySelector("#file-select-core").style.marginTop = "84px"
        document.querySelector("#file-select-core").style.height = "calc(100% - 100px - 36px)"
    }, 0)
    

    document.querySelector("#file-select .file-submit").onclick = function() {
        const obj = document.querySelector(".menu-row-dir-active")
        const fileSelect = document.querySelector("#file-select-keyword-path")
        let savePath = ""
        if(obj) {
            savePath = obj.dataset.filePath
        } else if(fileSelect) {
            savePath = fileSelect.value
        }

        if(!document.querySelector("#file-save-name").value) {
            alert("请输入文件名")
            return
        }
        
        saveLocalToService(savePath, fileName)
    }
}

function saveToService(event) {
    const fileName = document.querySelector(".menu-row-selected").title

    if(fileName) {
        event.preventDefault()
        event.stopPropagation()

        // 本地文件
        if(fileName.indexOf("file://") === 0) {
            openDirSelectSave(event, fileName)
            return
        }

        makeLine()
        saveLocalCache()

        const cache = localStorage.getItem(fileName)
        if(cache == null || cache == undefined) {
            console.log("无需保存")
            return
        }
        
        fetch("/file.php?act=save", {
            method: "post",
            body: JSON.stringify({
                path: fileName,
                content: localStorage.getItem(fileName)
            })
        }).then(function(body) {return body.json()}).then(function(data) {
            if(data === 0) {
                toLogin(function() {
                    saveToService(event)
                })
                return 
            }
            if(data.result == "ok") {
                localStorage.removeItem(fileName)
                fileHaveChange(fileName, 0)
                sourceContent[fileName] = data.content

                document.getElementById("content").value =  sourceContent[fileName]
                makeLine()
            }
        }).catch(function(e) {
            console.log(e)
        })
    }
}

function checkUpdate() {
}